#!/bin/bash
#
# (c) Copyright 2002 Hewlett-Packard Development Company, L.P.
#

if [ -z "$LOGFILE" ]; then
LOGFILE=/var/spool/compaq/cma.log
fi

#different distros put pidof in different places
if [ -f /sbin/pidof ]; then
  PIDOF=/sbin/pidof
elif [ -f /bin/pidof ]; then
  PIDOF=/bin/pidof
fi

#NAME="agent name"
#PNAME="cmaagentd"
#PFLAGS=

#chkhttpserverconfig () {
#  unset HPWEBSETUP
#  if [ -x /opt/compaq/foundation/etc/hpwebsetup ]; then
#    /opt/compaq/foundation/etc/hpwebsetup -q: >/dev/null 2>&1
#    if [ $? != 4 ]; then
#      cmaerr "ERROR: Can't start the Web agent. HP HTTP server must be configured"
#      cmaerr "       first. The minimum configuration required is the \"administrator\""
#      cmaerr "       password which can be configured with following command:"
#      cmaerr "       /opt/compaq/foundation/etc/hpwebsetup -pA:'yourpasswd' -f"
#    fi
#  fi
#  return 0
#}

cmaerr () {
  echo "  " $* >&2
  echo "  " $* >>$LOGFILE 2>&1
}

cmaecho () {
  echo "  " $*
  echo "  " $* >>$LOGFILE 2>&1
}

cmaechon () {
  echo -n "  " $*
  echo -n "  " $* >>$LOGFILE 2>&1
}

stopproc () {
	rc=1
	pidlist=`$PIDOF -o $$ $1`
  	for i in `seq 1 25`; do
		if [ -z "$pidlist" ]; then
			rc=0	
			break
		fi
		if [ "$i" = "1" ]; then
			kill $pidlist 2>/dev/null
		elif [ "$i" = "22" ]; then
			kill -9 $pidlist 2>/dev/null
		else
			sleep 1 
		fi
		pidlist=`$PIDOF -o $$ $1`
	done
	return $rc
}

RETVAL=0
PATH=/opt/compaq/foundation/bin:/opt/compaq/server/bin:/opt/compaq/hpasmd/bin:/opt/compaq/storage/bin:$PATH
#RHEL3 U3 did not like this, if LD_ASSUME_KERNEL needs to be set do it
#in the individual scripts 
#[ -z "$LD_ASSUME_KERNEL" ] && export LD_ASSUME_KERNEL=2.4.1
case "$1" in
  start)
	$STARTADDON	
	cmaechon "Starting $NAME ($PNAME): "
	pidlist=`$PIDOF -o $$ $PNAME`
	if [ -z "$pidlist" ]; then
	  $PNAME $PFLAGS < /dev/null >> $LOGFILE 2>&1 &
	  RETVAL=$?
	else
	  RETVAL=1
	fi
	cmaecho
	;;
  stop)
	$STOPADDON
	cmaechon "Shutting down $NAME ($PNAME): "
	stopproc $PNAME 
	RETVAL=$?
	cmaecho
	;;
  restart)
	$0 stop
	$0 start
	RETVAL=$?
	;;
  status)
        pid=`$PIDOF -o $$ -o $PPID -o %PPID -x $PNAME`
        if [ -n "$pid" ]; then
                echo "$PNAME is running..."
        else
                echo "$PNAME is stopped..."
        fi
	RETVAL=$?
	;;
  *)
	cmaecho "Usage: $PNAME {start|stop|restart|status}"
	exit 1
esac
exit $RETVAL
