#!/bin/sh

#Upgrade - stop everything
if [ "$1" = "2" ]; then
   if [ -x /opt/compaq/hpasm/etc/hpasm ]; then
	 #silentstop takes everything down (even other dependent services NOT contained in package)
	 # Do the silent stop feature first
	 sh /opt/compaq/hpasm/etc/hpasm silentstop 
	 if [ $? -ne 0 ]; then
	 	# If this did not work, go for the regular stop 
	 	sh /opt/compaq/hpasm/etc/hpasm stop 
	 fi
	 # No unconfigure necessary, since we will reconfigure anyway
   fi
fi

# Make some directories
if [ ! -d /var/spool/compaq/foundation/registry ]; then
   mkdir -p /var/spool/compaq/foundation/registry
   chmod 700 /var/spool/compaq
   chmod 700 /var/spool/compaq/foundation
   chmod 700 /var/spool/compaq/foundation/registry
fi
if [ ! -d /var/spool/compaq/server/registry ]; then
   mkdir -p /var/spool/compaq/server/registry
   chmod 700 /var/spool/compaq
   chmod 700 /var/spool/compaq/server
   chmod 700 /var/spool/compaq/server/registry
fi
#Debian does not have this directory predefined.
if [ ! -d /var/lock/subsys ]; then
   mkdir -p /var/lock/subsys
   chmod 700 /var/lock/subsys
fi

# group add hpsmh - this is for cleansweep
if [ ! -z `egrep "^hpsmh" /etc/group | grep -v ":79:"` ]; then
	groupdel hpsmh > /dev/null 2> /dev/null
fi
if [ -z `egrep "^hpsmh" /etc/group` ]; then
	groupadd -g 79 hpsmh > /dev/null 2> /dev/null
fi
#user add hpsmh - for cleansweep
if [ ! -z `egrep "^hpsmh" /etc/passwd| grep -v ":79:"` ]; then
	userdel hpsmh > /dev/null 2> /dev/null
fi
if [ -z `egrep "^hpsmh" /etc/passwd` ]; then
	useradd -u 79 -g 79 -s /sbin/nologin -M -r -d /opt/hp/hpsmh hpsmh > /dev/null 2> /dev/null
fi

#Legacy Maintenance

#Old hpasm or cpqhealth
if [ -d /opt/compaq/cpqhealth ]; then
   echo "This release of hpasm cannot be installed because it"
   echo "will conflict with a package already installed."
   echo "Please remove the current hpasm or cpqhealth that"
   echo "is installed before upgrading to this release."
   echo "Use 'rpm -e' to remove the old package."
   exit 1
fi

#Old Foundation
if [ -f /etc/init.d/cmafdtn ]; then
	echo "This release of cmafdtn cannot be upgraded."
	echo "Please remove the installed 'cmafdtn' RPM before upgrading"
	echo "to this release. Use 'rpm -e cmafdtn' to remove."
	echo "You may also want to remove the cmaX enabled snmp stack and"
	echo "reinstall the standard snmp package from your Linux distribution."
	exit 1
fi

#Old Server 
if [ -f /etc/init.d/cmasvr ]; then
	echo "This release of cmasvr cannot be upgraded."
	echo "Please remove the installed 'cmasvr' RPM before upgrading"
	echo "to this release. Use 'rpm -e cmasvr' to remove."
	echo "You may also want to remove the cmaX enabled snmp stack and"
	echo "reinstall the standard snmp package from your Linux distribution."
	exit 1
fi

#Old Storage 
if [ -f /etc/init.d/cmastor ]; then
	echo "This release of cmastor cannot be upgraded."
	echo "Please remove the installed 'cmastor' RPM before upgrading"
	echo "to this release. Use 'rpm -e cmastor' to remove."
	echo "You may also want to remove the cmaX enabled snmp stack and"
	echo "reinstall the standard snmp package from your Linux distribution."
	exit 1
fi

#TODO: Old Nic agents

#
# We need to clean up from previously installed versions which
# did not delete all instances of the driver
#

for OS_VER in `ls -d /lib/modules/*`; do
	#Now wipe all occurences of cpqhealth and cpqrom in the current directory.
        rm -f $OS_VER/misc/cpqhealth.o
        rm -f $OS_VER/misc/cpqrom.o
        rm -f $OS_VER/kernel/drivers/char/cpqhealth.o
        rm -f $OS_VER/kernel/drivers/char/cpqrom.o
done;

CPQASM=`/sbin/lsmod |fgrep cpqasm`
if [ ${#CPQASM} -ne 0 ]; then
   echo "WARNING!  Not able to stop the cpqasm device driver!"
   exit 1
fi


#
# RPM Upgrade may be in process.  We need to clean up a bit
#
if [ -f /sbin/cpqimlview ]; then
	echo "Starting hpasm package Upgrade. . ."
	rm -f /lib/modules/Compaq/drivers/up/cpqasm.o
	rm -f /lib/modules/Compaq/drivers/smp/cpqasm.o
	rm -f /lib/modules/Compaq/drivers/ent/cpqasm.o
	rm -f /opt/compaq/cpqhealth/cpqasm/casmw_linux.o
	rm -f /sbin/cpqimlview
	rm -f /sbin/cpqimlview.tcl
	rm -f /sbin/imlbe
	rm -f /sbin/hpimlview
	rm -f /usr/share/pixmaps/compred.xbm
	rm -f /usr/share/pixmaps/hplogo.xbm
	rm -f /usr/share/pixmaps/m_blue.gif
	rm -f /usr/share/pixmaps/m_fail.gif
	rm -f /usr/share/pixmaps/m_green.gif
	rm -f /usr/share/pixmaps/m_red.gif
	rm -f /usr/share/pixmaps/m_yellow.gif
	for NODE in \
	casm casr cecc ccsm cmca cside cevt cpci cdt cpqw crom cwell cpqevt
	do
		rm -f /dev/$NODE
		rm -f /dev/cpqhealth/$NODE
	done
	rm -f /lib/modules/Compaq/drivers/up/cpqevt.o
	rm -f /lib/modules/Compaq/drivers/smp/cpqevt.o
	rm -f /lib/modules/Compaq/drivers/ent/cpqevt.o
	rm -f /opt/compaq/cpqhealth/cpqevt/cpqevtw_linux.o
        rm -rf /opt/compaq/cpqhealth
fi

#remove old cmhp driver
if [ -d /opt/compaq/cmhp ]; then
   rm -rf /opt/compaq/cmhp
fi